SystemOrganization addCategory: #'Rest-Tests'!
SystemOrganization addCategory: #'Rest-Tests-Server'!
SystemOrganization addCategory: #'Rest-Tests-Fixtures'!
SystemOrganization addCategory: #'Rest-Tests-Client'!

RestHttpHandler subclass: #RestPerformHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestPerformHttpHandler methodsFor: 'request processing' stamp: 'cs 2/19/2009 17:51'!
process: anHTTPRequest
	"Takes first element in path as classname and sends message from third path element to that class."

	|pc class selector result|
	pc := anHTTPRequest uri identifierPath.
	class := pc second asSymbol.
	selector := pc third asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [
			result := c perform: selector]].

	^ HTTPResponse ok
		entity: result asString;
		yourself! !

Object subclass: #RestProxyObjectFactoryMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestProxyObjectFactoryMock methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 18:32'!
getObject: aString

	^ RestProxyObject new! !

Object subclass: #TestEntity
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity subclass: #SecondLevelTestObject
	instanceVariableNames: 'name testObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:34'!
newFrom: aDictionary
	^ self new name: (aDictionary at: 'name')! !

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:55'!
primitivePropertyNames
	^ #(id name)! !

!SecondLevelTestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:35'!
delete
	self testObject removeSecondLevelTestObject: self.! !

!SecondLevelTestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 13:55'!
name
	^ name! !

!SecondLevelTestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 13:55'!
name: aString
	name := aString.! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:33'!
testObject
	^ testObject! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:33'!
testObject: anObject
	testObject := anObject! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:55'!
collectionPropertyNames
	^ #()! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:38'!
incrementId

	self pvtLastId: self pvtLastId + 1.
	^ self pvtLastId! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
initialize

	super initialize.
	self pvtLastId: 0.! !

!TestEntity class methodsFor: 'instance creation' stamp: 'cs 2/27/2009 12:34'!
prepare
	TestObject testObjects: OrderedCollection new.
	TestObject addTest: (TestObject new
		firstName: 'Test';
		lastName: 'Project';
		id: 1;
		addSecondLevelTestObject: (SecondLevelTestObject new name: 'Micha');
		yourself).
	TestObject addTest: (TestObject new
		firstName: 'Test2';
		lastName: 'Project2';
		id: 2).
	TestObject addTest: (TestObject new
		firstName: 'Test3';
		lastName: 'Project3';
		id: 3).
		! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:55'!
primitivePropertyNames
	^ #()! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
pvtLastId

	^ lastId ifNil: [lastId := 0]! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
pvtLastId: anObject

	lastId := anObject! !

!TestEntity methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:13'!
id
	^ id! !

!TestEntity methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:13'!
id: anObject
	id := anObject! !

!TestEntity methodsFor: 'printing' stamp: 'SR 2/26/2009 15:45'!
jsonWriteOn: aStream
	| result |
	result := Dictionary newFrom: (self class primitivePropertyNames collect: [ :aSymbol |
			aSymbol -> (self perform: aSymbol)]).
	result addAll: (Dictionary newFrom: (self class collectionPropertyNames collect: [ :aSymbol |
			aSymbol -> ((self perform: aSymbol) collect: [:each | each restUri])])).
	result jsonWriteOn: aStream.! !

!TestEntity methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:13'!
restUri

	^ (RestMockResourceHttpHandler uriMapping at: self class) value: self! !

TestEntity subclass: #TestObject
	instanceVariableNames: 'firstName lastName secondLevelTestObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestObject class
	instanceVariableNames: 'testObjects'!

TestObject class
	instanceVariableNames: 'testObjects'!

!TestObject class methodsFor: 'as yet unclassified' stamp: 'cs 2/27/2009 12:33'!
addNewTest: aDictionary 
	^ self addTest: (self newFrom: aDictionary)! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'cs 2/27/2009 12:33'!
addTest: aTestObject
	self testObjects add: aTestObject.
	aTestObject id: self incrementId.
	^ aTestObject! !

!TestObject class methodsFor: 'instance creation' stamp: 'SR 2/26/2009 14:00'!
all
	^ self testObjects! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:41'!
collectionPropertyNames
	^ #(secondLevelTestObjects)! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:33'!
newFrom: aDictionary
	^ self new
		firstName: (aDictionary at: 'firstName');
		lastName: (aDictionary at: 'lastName')! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:49'!
primitivePropertyNames
	^ #(id firstName lastName)! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:30'!
removeTestObject: aTestObject
	
	self testObjects remove: aTestObject.! !

!TestObject class methodsFor: 'instance creation' stamp: 'SR 2/26/2009 14:00'!
testObjects
	^ testObjects! !

!TestObject class methodsFor: 'instance creation' stamp: 'SR 2/26/2009 15:14'!
testObjects: aCollection
	testObjects := aCollection! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:27'!
addNewSecondLevelTestObject: aDictionary

	^ self addSecondLevelTestObject: (SecondLevelTestObject newFrom: aDictionary)! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:25'!
addSecondLevelTestObject: aSecondLevelTestObject 

	aSecondLevelTestObject
		testObject: self;
		id: aSecondLevelTestObject class incrementId.
	^ self secondLevelTestObjects add: aSecondLevelTestObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:29'!
delete
	^ self class removeTestObject: self! !

!TestObject methodsFor: 'accessing' stamp: 'topa 2/25/2009 11:31'!
firstName
	^ firstName! !

!TestObject methodsFor: 'accessing' stamp: 'topa 2/25/2009 11:31'!
firstName: anObject
	firstName := anObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:48'!
initialize
	super initialize.
	self secondLevelTestObjects: OrderedCollection new.! !

!TestObject methodsFor: 'accessing' stamp: 'topa 2/25/2009 11:31'!
lastName
	^ lastName! !

!TestObject methodsFor: 'accessing' stamp: 'cs 2/27/2009 14:01'!
lastName: anObject
	lastName := anObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:29'!
removeSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects remove: aSecondLevelTestObject ifAbsent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject: nil.
	^ aSecondLevelTestObject! !

!TestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:25'!
secondLevelTestObjects
	^ secondLevelTestObjects! !

!TestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:25'!
secondLevelTestObjects: anObject
	secondLevelTestObjects := anObject! !

RestResourceHttpHandler subclass: #RestMockResourceHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'mfp 2/24/2009 14:30'!
rootResources
	^ Dictionary newFrom:
		{'tests' -> TestObject }! !

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'cs 2/27/2009 14:25'!
uriMapping

	^ Dictionary newFrom:{
		TestObject -> [:test| '/tests/{1}' format: {test id}].
		SecondLevelTestObject -> [:test | '/tests/{1}/secondLevel/{2}' format: {test testObject id. test id}]}! !

!Dictionary methodsFor: '*rest-tests' stamp: 'mt 2/16/2009 10:28'!
keysAndValuesCollect: aBlock 
	| newDict |
	newDict := Dictionary new.
	self keysAndValuesDo: [:key :value | newDict add: (aBlock value: key value: value)].
	^ newDict! !

TestCase subclass: #RestSocketTestCase
	instanceVariableNames: 'site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'cs 2/19/2009 20:47'!
httpUrl
	^ 'http://www.google.com' asUrl! !

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'topa 2/19/2009 19:10'!
url
	^ 'https://www.verisign.com/favicon.ico' asUrl! !

!RestSocketTestCase methodsFor: 'tests' stamp: 'mig 2/23/2009 16:45'!
testDefaultReturn

	self
		should: ((RestSocket    getDocumentFromUrl: self class httpUrl request: '') isKindOf: RestResponse);
		should: ((RestSocket    getDocumentFromUrl: self class url request: '') isKindOf: RestResponse);
		should: ((RestSocket    putDocumentFromUrl: self class url request: '' content: 'foo') isKindOf: RestResponse);
		should: ((RestSocket   postDocumentFromUrl: self class url request: '' content: 'bar') isKindOf: RestResponse);
		should: ((RestSocket deleteDocumentFromUrl: self class url request: '') isKindOf: RestResponse).! !

TestCase subclass: #RestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

RestTest subclass: #RestHttpServiceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestHttpServiceTest methodsFor: 'running' stamp: 'topa 2/25/2009 13:28'!
setUp
	"avoid upcall"! !

!RestHttpServiceTest methodsFor: 'tests' stamp: 'topa 2/26/2009 19:39'!
testStartAndStop
	
	RestHttpService startOn: self class port.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isKindOf: RestHttpService);
		should: RestHttpService isRunning.
	
	RestHttpService stop.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isNil);
		shouldnt: RestHttpService isRunning.! !

RestTest subclass: #RestObjectTest
	instanceVariableNames: 'sut testObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestObjectTest methodsFor: 'running' stamp: 'topa 3/3/2009 18:34'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler on: '/'.
	TestEntity prepare.

	testObject := TestObject all first.
	sut := (RestProxyObject fromServer: self class url
				path: 'tests/' , testObject id asString)
				factory: RestProxyObjectFactoryMock new.! !

!RestObjectTest methodsFor: 'tests' stamp: 'topa 3/3/2009 18:04'!
testDeleteRestObject

	| oldCount |
	oldCount := TestObject all size.

	sut delete.

	self should: TestObject all size = (oldCount - 1).
	[(RestProxyObject fromServer: self class url
		path: 'tests/' , testObject id asString)
		title] 
	on: Exception
	do: [^ self].
			
	self fail.! !

!RestObjectTest methodsFor: 'tests' stamp: 'topa 3/3/2009 18:01'!
testGetRestObject

	self
		should: sut firstName = testObject firstName;
		should: sut lastName = testObject lastName;
		should: sut id = testObject id;
		should: 
			sut secondLevelTestObjects size = testObject secondLevelTestObjects size.! !

!RestObjectTest methodsFor: 'tests' stamp: 'topa 3/3/2009 18:35'!
testUpdateRestObject
	| sut2 |

	sut
		firstName: 'New First Name!!';
		lastName: 'New Last Name!!'.
	self
		should: testObject firstName = 'New First Name!!';
		should: testObject lastName = 'New Last Name!!'.
	sut2 := (RestProxyObject fromServer: self class url
				path: 'tests/' , testObject id asString)
				factory: sut factory.
	self
		should: sut2 firstName = 'New First Name!!';
		should: sut2 lastName = 'New Last Name!!'! !

RestTest subclass: #RestPerformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestPerformTest methodsFor: 'running' stamp: 'cs 2/24/2009 17:36'!
setUp
	super setUp.
	RestHttpService resource
		installHandler: RestPerformHttpHandler
		on: '/'! !

!RestPerformTest methodsFor: 'tests' stamp: 'mt 2/23/2009 12:18'!
testPort
	| response |
	response := self get: 'RestHttpService/port'.
	self should: response content = RestHttpService port asString.! !

RestTest subclass: #RestProxyObjectFactoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestProxyObjectFactoryTest methodsFor: 'running' stamp: 'topa 3/3/2009 17:55'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler on: '/'.
	TestEntity prepare.
	
	sut := RestProxyObjectFactory fromString: self class url.! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'topa 3/3/2009 17:54'!
testRestObjectFactoryAdd

	| object testObject oldCount |
	oldCount := TestObject all size.
	object := sut 
		addObject: 'tests/'
		with: (TestObject new
			firstName: 'New Test';
			lastName: 'for Factory').
	testObject := TestObject all last.
	self
		should: TestObject all size = (oldCount + 1);
		should: object firstName = testObject firstName;
		should: object lastName = testObject lastName;
		should: object id = testObject id! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'topa 3/3/2009 17:52'!
testRestObjectFactoryGet

	| sut object testObject |
	testObject := TestObject all first.
	sut := RestProxyObjectFactory fromString: self class url.
	object := sut getObject: 'tests/' , testObject id asString.
	self
		should: object firstName = testObject firstName;
		should: object lastName = testObject lastName;
		should: object id = testObject id! !

!RestProxyObjectFactoryTest methodsFor: 'tests' stamp: 'topa 3/3/2009 17:56'!
testRestObjectFactoryGetCollection

	| testObjects collection |
	testObjects := TestObject all.
	collection := sut getCollection: 'tests/'.

	self should: collection size = testObjects size.
	collection do: [:eachSut | 
		self should: (testObjects anySatisfy: [:eachTestObject | 
			eachSut id = eachTestObject id 
			and: [eachSut firstName = eachTestObject firstName]
			and: [eachSut lastName = eachTestObject lastName]])]! !

!RestTest class methodsFor: 'fixture-data' stamp: 'cs 2/27/2009 11:52'!
host
	^ 'localhost'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'cs 2/27/2009 11:52'!
ip
	^ '127.0.0.1'! !

!RestTest class methodsFor: 'testing' stamp: 'cs 2/15/2009 14:14'!
isAbstract
	^ self name = 'RestTest'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 2/26/2009 19:45'!
port
	^ 58082! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 2/26/2009 19:48'!
url
	
	^ 'http://{1}:{2}/' format: {self ip. self port}! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/3/2009 16:33'!
delete: aPath
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ RestSocket
		deleteDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/3/2009 16:34'!
get: aPath
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."
	^ RestSocket
		getDocumentFromUrl: (self class url, aPath) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'mt 2/18/2009 15:09'!
jsonDataFrom: someFields
	"Create a string for all fields in the dictionary in JSON."
	
	| stream |
	stream := TextStream with: ''.
	(Dictionary newFrom: someFields) jsonWriteOn: stream.	
	^ stream contents! !

!RestTest methodsFor: 'helping' stamp: 'topa 2/26/2009 19:39'!
post: aPath content: aContent
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service. Append the given fields to the request body."

	^ RestSocket
		postDocumentFromUrl: (('http://localhost:{1}/{2}' format: {self class port. aPath}) asUrl)
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'topa 3/3/2009 16:33'!
put: aPath content: aContent
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. Append the given fields to the request body."
	
	^ RestSocket
		putDocumentFromUrl: (self class url, aPath) asUrl
		request: ''
		content: aContent! !

!RestTest methodsFor: 'running' stamp: 'topa 3/3/2009 18:37'!
setUp

	super setUp.
	RestHttpService startOn: self class port.
! !

!RestTest methodsFor: 'running' stamp: 'topa 3/3/2009 18:37'!
tearDown

	RestHttpService stop.! !
TestEntity initialize!
